#include "Instance.h"

#include <iostream>

void Instance::add_argument(std::string arg)
{
    arg_to_index[arg] = arguments.size();
    index_to_arg[arguments.size()] = arg;
    arguments.push_back(arguments.size());
}

void Instance::add_example(Example ex)
{
    example_id_to_index[ex.id] = examples.size();
    index_to_example_id[examples.size()] = ex.id;
    examples.push_back(ex);
}

void Instance::initialize(int flag)
{
	for (int i = 0; i < arguments.size(); i++) {
		for (int j = 0; j < arguments.size(); j++) {
			attack_var[std::make_pair(arguments[i], arguments[j])] = ++count;
			var_attack[count] = std::make_pair(arguments[i], arguments[j]);
		}
	}
	for (int i = 0; i < examples.size(); i++) {
		extension_var[examples[i].id] = ++count;
		var_extension[count] = examples[i].id;
	}
	for (int i = 0; i < examples.size(); i++) {
		if ((flag || !examples[i].pos) && examples[i].sem == "adm") {
		for (int j = 0; j < arguments.size(); j++) {
			if (examples[i].arg_in_ex[arguments[j]]) {
				for (int k = 0; k < arguments.size(); k++) {
					if (!examples[i].arg_in_ex[arguments[k]]) {
						not_defended_var[std::make_pair(examples[i].id, std::make_pair(arguments[j], arguments[k]))] = ++count;
					}
				}
			}
		}
		}
	}
	for (int i = 0; i < examples.size(); i++) {
		if ((flag || !examples[i].pos) && examples[i].sem == "stb") {
		for (int j = 0; j < arguments.size(); j++) {
			if (!examples[i].arg_in_ex[arguments[j]]) {
				not_attacked_var[std::make_pair(examples[i].id, arguments[j])] = ++count;
			}
		}
		}
	}
}

void Instance::print()
{
	std::cout << "Arguments:\n";
	for (int i = 0; i < arguments.size(); i++) {
		std::cout << "arg " << index_to_arg[arguments[i]] << "\n";
	}
	std::cout << "Examples:\n";
	for (int i = 0; i < examples.size(); i++) {
		std::cout << examples[i].pos << " ex " << examples[i].id << "\n";
		std::cout << "weight " << examples[i].weight << "\n";
		std::cout << "sem " << examples[i].sem << "\n";
		std::cout << "args ";
		for (int j = 0; j < arguments.size(); j++) {
			if (examples[i].arg_in_ex[arguments[j]]) {
				std::cout << index_to_arg[arguments[j]] << " ";
			}
		}
		std::cout << "\n";
	}
}