#ifndef MAXSAT_SOLVER_H
#define MAXSAT_SOLVER_H

#include <vector>
#include <map>

class MaxSATSolver {

public:

	std::vector<std::vector<int>> hard_clauses;
	std::vector<std::pair<int,std::vector<int>>> soft_clauses;
	std::map<int,bool> assignment;

	MaxSATSolver() {}
	virtual ~MaxSATSolver() {}
	virtual void add_hard_clause(std::vector<int> & clause) =0;
	virtual void add_soft_clause(int weight, std::vector<int> & clause) =0;
	virtual void solve() =0;

};

#endif