#include "Synthesis.h"

#include "OpenWBOSolver.h"
typedef OpenWBOSolver MaxSAT_Solver;

#include <iostream>
#include <fstream>

namespace Synthesis {

using namespace std;

int flag;

vector<vector<int>> cf_clauses(Instance & inst, Example & ex)
{
	vector<vector<int>> clauses;
	if (flag || ex.pos) {
		for (int i = 0; i < inst.arguments.size(); i++) {
			if (ex.arg_in_ex[inst.arguments[i]]) {
				for (int j = 0; j < inst.arguments.size(); j++) {
					if (ex.arg_in_ex[inst.arguments[j]]) {
						vector<int> clause;
						clause.push_back(-inst.extension_var[ex.id]);
						clause.push_back(-inst.attack_var[make_pair(inst.arguments[i], inst.arguments[j])]);
						clauses.push_back(clause);
					}
				}
			}
		}
	}
	if (flag || !ex.pos) {
		vector<int> clause;
		for (int i = 0; i < inst.arguments.size(); i++) {
			if (ex.arg_in_ex[inst.arguments[i]]) {
				for (int j = 0; j < inst.arguments.size(); j++) {
					if (ex.arg_in_ex[inst.arguments[j]]) {
						clause.push_back(inst.attack_var[make_pair(inst.arguments[i], inst.arguments[j])]);
					}
				}
			}
		}
		clause.push_back(inst.extension_var[ex.id]);
		clauses.push_back(clause);
	}
	return clauses;
}

vector<vector<int>> adm_clauses(Instance & inst, Example & ex)
{
	vector<vector<int>> clauses;
	if (flag || ex.pos) {
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (ex.arg_in_ex[inst.arguments[i]]) {
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (ex.arg_in_ex[inst.arguments[j]]) {
					vector<int> clause;
					clause.push_back(-inst.extension_var[ex.id]);
					clause.push_back(-inst.attack_var[make_pair(inst.arguments[i], inst.arguments[j])]);
					clauses.push_back(clause);
				}
			}
		}
	}
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (ex.arg_in_ex[inst.arguments[i]]) {
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (!ex.arg_in_ex[inst.arguments[j]]) {
					vector<int> clause;
					clause.push_back(-inst.extension_var[ex.id]);
					clause.push_back(-inst.attack_var[make_pair(inst.arguments[j], inst.arguments[i])]);
					for (int k = 0; k < inst.arguments.size(); k++) {
						if (ex.arg_in_ex[inst.arguments[k]]) {
							clause.push_back(inst.attack_var[make_pair(inst.arguments[k], inst.arguments[j])]);
						}
					}
					clauses.push_back(clause);
				}
			}
		}
	}
	}
	if (flag || !ex.pos) {
	vector<int> clause;
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (ex.arg_in_ex[inst.arguments[i]]) {
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (ex.arg_in_ex[inst.arguments[j]]) {
					clause.push_back(inst.attack_var[make_pair(inst.arguments[i], inst.arguments[j])]);
				}
			}
		}
	}
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (ex.arg_in_ex[inst.arguments[i]]) {
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (!ex.arg_in_ex[inst.arguments[j]]) {
					clause.push_back(inst.not_defended_var[make_pair(ex.id, make_pair(inst.arguments[i], inst.arguments[j]))]);
				}
			}
		}
	}
	clause.push_back(inst.extension_var[ex.id]);
	clauses.push_back(clause);
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (ex.arg_in_ex[inst.arguments[i]]) {
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (!ex.arg_in_ex[inst.arguments[j]]) {
					vector<int> clause;
					clause.push_back(-inst.not_defended_var[make_pair(ex.id, make_pair(inst.arguments[i], inst.arguments[j]))]);
					clause.push_back(inst.attack_var[make_pair(inst.arguments[j], inst.arguments[i])]);
					clauses.push_back(clause);
					for (int k = 0; k < inst.arguments.size(); k++) {
						if (ex.arg_in_ex[inst.arguments[k]]) {
							vector<int> clause;
							clause.push_back(-inst.not_defended_var[make_pair(ex.id, make_pair(inst.arguments[i], inst.arguments[j]))]);
							clause.push_back(-inst.attack_var[make_pair(inst.arguments[k], inst.arguments[j])]);
							clauses.push_back(clause);
						}
					}
				}
			}
		}
	}
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (ex.arg_in_ex[inst.arguments[i]]) {
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (!ex.arg_in_ex[inst.arguments[j]]) {
					vector<int> clause;
					clause.push_back(-inst.attack_var[make_pair(inst.arguments[j], inst.arguments[i])]);
					for (int k = 0; k < inst.arguments.size(); k++) {
						if (ex.arg_in_ex[inst.arguments[k]]) {
							clause.push_back(inst.attack_var[make_pair(inst.arguments[k], inst.arguments[j])]);
						}
					}
					clause.push_back(inst.not_defended_var[make_pair(ex.id, make_pair(inst.arguments[i], inst.arguments[j]))]);
					clauses.push_back(clause);
				}
			}
		}
	}
	}
	return clauses;
}

vector<vector<int>> stb_clauses(Instance & inst, Example & ex)
{
	vector<vector<int>> clauses;
	if (flag || ex.pos) {
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (ex.arg_in_ex[inst.arguments[i]]) {
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (ex.arg_in_ex[inst.arguments[j]]) {
					vector<int> clause;
					clause.push_back(-inst.extension_var[ex.id]);
					clause.push_back(-inst.attack_var[make_pair(inst.arguments[i], inst.arguments[j])]);
					clauses.push_back(clause);
				}
			}
		}
	}
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (!ex.arg_in_ex[inst.arguments[i]]) {
			vector<int> clause;
			clause.push_back(-inst.extension_var[ex.id]);
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (ex.arg_in_ex[inst.arguments[j]]) {
					clause.push_back(inst.attack_var[make_pair(inst.arguments[j], inst.arguments[i])]);
				}
			}
			clauses.push_back(clause);
		}
	}
	}
	if (flag || !ex.pos) {
	vector<int> clause;
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (ex.arg_in_ex[inst.arguments[i]]) {
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (ex.arg_in_ex[inst.arguments[j]]) {
					clause.push_back(inst.attack_var[make_pair(inst.arguments[i], inst.arguments[j])]);
				}
			}
		}
	}
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (!ex.arg_in_ex[inst.arguments[i]]) {
			clause.push_back(inst.not_attacked_var[make_pair(ex.id, inst.arguments[i])]);
		}
	}
	clause.push_back(inst.extension_var[ex.id]);
	clauses.push_back(clause);
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (!ex.arg_in_ex[inst.arguments[i]]) {
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (ex.arg_in_ex[inst.arguments[j]]) {
					vector<int> clause;
					clause.push_back(-inst.not_attacked_var[make_pair(ex.id, inst.arguments[i])]);
					clause.push_back(-inst.attack_var[make_pair(inst.arguments[j], inst.arguments[i])]);
					clauses.push_back(clause);
				}
			}
		}
	}
	for (int i = 0; i < inst.arguments.size(); i++) {
		if (!ex.arg_in_ex[inst.arguments[i]]) {
			vector<int> clause;
			for (int j = 0; j < inst.arguments.size(); j++) {
				if (ex.arg_in_ex[inst.arguments[j]]) {
					clause.push_back(inst.attack_var[make_pair(inst.arguments[j], inst.arguments[i])]);
				}
			}
			clause.push_back(inst.not_attacked_var[make_pair(ex.id, inst.arguments[i])]);
			clauses.push_back(clause);
		}
	}
	}
	return clauses;	
}

/*!
 * Wcnf file output.
 *
 * nbvar - number of variables
 * nbclauses - number of clauses
 * top - weight assigned to hard clauses
 * hard_clauses - hard clauses in MaxSAT instance
 * soft_clauses - soft clauses in MaxSAT instance
 * weights - weights of soft clauses
 * filename - name of output file
 */
bool write_wcnf_to_file(int nbvar, int nbclauses, int top, 
                   vector<vector<int>>& hard_clauses, 
                   vector<vector<int>>& soft_clauses,
                   vector<int> & weights, 
                   string filename)
{
    ofstream file(filename);
    if (file.is_open()) {
        file << "p wcnf " << nbvar << " " << nbclauses << " " << top << "\n";
        for (int i = 0; i < hard_clauses.size(); i++) {
            file << top << " ";
            for (int j = 0; j < hard_clauses[i].size(); j++) {
                file << hard_clauses[i][j] << " ";
            }
            file << "0\n";
        }
        for (int i = 0; i < soft_clauses.size(); i++) {
            file << weights[i] << " ";
            for (int j = 0; j < soft_clauses[i].size(); j++) {
                file << soft_clauses[i][j] << " ";
            }
            file << "0\n";
        }
        return true;
    }
    return false;
}

void synthesize(Instance & inst, string outfile, int flag)
{
	flag = flag;
	vector<vector<int>> hard_clauses;
	vector<vector<int>> soft_clauses;
	vector<int> weights;
	int top = 1;
	for (int i = 0; i < inst.examples.size(); i++) {
		vector<vector<int>> tmp;
		if (inst.examples[i].sem == "cf") {
			tmp = cf_clauses(inst, inst.examples[i]);
		} else if (inst.examples[i].sem == "adm") {
			tmp = adm_clauses(inst, inst.examples[i]);
		} else if (inst.examples[i].sem == "stb") {
			tmp = stb_clauses(inst, inst.examples[i]);
		}
		hard_clauses.insert(hard_clauses.end(), tmp.begin(), tmp.end());
		vector<int> clause;
		if (inst.examples[i].pos) {
			clause.push_back(inst.extension_var[inst.examples[i].id]);
		} else {
			clause.push_back(-inst.extension_var[inst.examples[i].id]);
		}
		soft_clauses.push_back(clause);
		weights.push_back(inst.examples[i].weight);
		top += inst.examples[i].weight;
	}
	// if file specified output wcnf/lp and exit
    if (outfile != "") {
    	/*
        int nbvar = 0;
        for (int i = 0; i < hard_clauses.size(); i++) {
            for (int j = 0; j < hard_clauses[i].size(); j++) {
                nbvar = max(nbvar, abs(hard_clauses[i][j]));
            }
        }
        for (int i = 0; i < soft_clauses.size(); i++) {
            for (int j = 0; j < soft_clauses[i].size(); j++) {
                nbvar = max(nbvar, abs(soft_clauses[i][j]));
            }
        }
        */
        write_wcnf_to_file(inst.count, hard_clauses.size() + soft_clauses.size(),
        				   top, hard_clauses, soft_clauses, weights, outfile);
    }
    
    // initialize MaxSAT solver
    MaxSAT_Solver maxsat_solver = MaxSAT_Solver();

    // add generated clauses to MaxSAT solver    
    for (int i = 0; i < hard_clauses.size(); i++) {
        maxsat_solver.add_hard_clause(hard_clauses[i]);
    }
    for (int i = 0; i < soft_clauses.size(); i++) {
        maxsat_solver.add_soft_clause(weights[i], soft_clauses[i]);
    }

    // generate attack structure from truth assignment
    maxsat_solver.solve();
    for (int i = 0; i < maxsat_solver.assignment.rbegin()->first; i++) {
    	if (inst.var_extension.find(i+1) != inst.var_extension.end()) {
    		inst.examples[inst.example_id_to_index[inst.var_extension[i+1]]].sat = maxsat_solver.assignment[i];
    	}
        if (inst.var_attack.find(i+1) != inst.var_attack.end() && maxsat_solver.assignment[i]) {
        	inst.attacks.push_back(make_pair(inst.var_attack[i+1].first, inst.var_attack[i+1].second));
        }
    }

}

}